*:*********************************************************************
*:
*:        Program: BIGLETTS.PRG
*:
*:         System: 
*:         Author: Robert L. Morgan
*:      Copyright (c) 1991, Robert L. Morgan /dba Morgan Consulting
*:  Last modified: 05/12/91      5:46
*:
*:  Procs & Fncts: BIG_LET()
*:
*:          Calls: BIG_LET()      (function  in BIGLETTS.PRG)
*:
*:      Documented 05/12/91 at 05:46                SNAP!  version 4.00
*:*********************************************************************
*ķ
*                                                                            
*       Program: BIGLETTS.PRG                                                
*                                                                            
*        System:                                                             
*        Author: PHIL BARNETT    / MODIFIED BY RL MORGAN                     
*     Copyright                                                              
* Last modified: 05/13/91                                                    
*                                                                            
* Procs & Fncts: BIG_LET()                                                   
*                                                                            
*         Calls: BIG_LET()      (function  in BIGLETTS.PRG)                  
*                                                                            
*      Documented 05/13/91                                                   
*Ľ
*ķ
* This is a partialy modified version of the big letters program             
* originaly done by Phil Barnett of Orlando Fl. I have always wanted         
* to be able to quickly come up with a special looking screen for my         
* clients on the fly, even if it was just a temp. to hold them until         
* the final was done. I am a strong proponent of attractive applications.    
*                                                                            
* Phil finaly did what I have been trying to get around to for a long time.  
* He created a function that you can pass a string to, and simply place      
* big letters on the screen for a nice touch of class to an otherwise        
* very cumbersom (graphics wise) language.                                   
*                                                                            
* If you will take the time now to modify it and link it into your lib       
* you too will be able to givem a little sizzle for their buck.              
*                                                                            
* What I did here was to create a header that has a clock of about           
* 7 bigletters. I modified several small lines and all of                    
* the original ALPHA letters. I did not get to the !@#$% etc. Ill let you    
* do that and you can send it back to the Orlando Bullet (407) 277-2007 with 
* those modifications finished.                                              
*Ķ
* After compiling to BIGLETTS.EXE. From dos call the .EXE as shown bellow    
*                                                                            
* Example Call: BIGLETTS TESTING                                             
*Ķ
* After that you will get the idea. Modify your brains out, and HEY!         
* SEND US A COPY OF THE CODE, so we can bragg about how we changed the       
* way someone displays screens <grin>.                                       
*                                                                            
* I have included a 5.01 compiled and linked version of the .EXE about       
* 18k just be sure you use the 'SET PLL=<your path>' to your PLL file.       
* It's gonna look for BASE50. Otherwise compile it your self.                
*                                                                            
* Enjoy,create and SHARE.                                                    
*Ķ
*                                                                            
* Best wishes and GOOD-BYE from the Sunshine State,                          
*                                                                            
* Bob Morgan                                                                 
* Sysop                                                                      
* The Orlando Bullet                                                         
* Orlando FL                                                                 
* 407 277-2007                                                               
*                                                                            
*Ľ


PARAMETER P1,P2,P3,P4

Numparam = PCOUNT()

DO CASE
CASE Numparam = 0
   Phrase = ''
CASE Numparam = 1
   Phrase = P1
CASE Numparam = 2
   Phrase = P1 + ' ' + P2
CASE Numparam = 3
   Phrase = P1 + ' ' + P2 + ' ' + P3
CASE Numparam = 4
   Phrase = P1 + ' ' + P2 + ' ' + P3 + ' ' + P4
ENDCASE

CLEAR
SET Cursor OFF
KEY   =  0
Red   = 'R'
Green = 'GR+'

IF ISCOLOR()
   SET COLOR TO &red
ENDIF

Big_let(0,1,Phrase)

IF ISCOLOR()
   SET COLOR TO &green
ENDIF

Newcol = '1'
Click  =  0

DO WHILE KEY = 0
   KEY=INKEY()
   Big_let(10,1,Ampm(TIME()))        && Centers the clock on the screen
   Click    = Click + 1
   IF Click = 20
      Newcol   = ALLTRIM(STR(IIF(!VAL(Newcol) + 1 > 15,VAL(Newcol)+1,1)))
      Newcol   = Newcol+'/0,9/0,,,9/0'
      SETCOLOR(Newcol)
      Click    = 0
   ENDIF
ENDDO

*  big_let(10,1,ampm(time()))     && places the clock on column 1
SET Cursor ON
RETURN

*Ŀ
*                                                                   
*      Function: BIG_LET()                                          
*                                                                   
*     Called by: BIGLETTS.PRG                                       
*                                                                   
*
FUNCTION Big_let

PARAMETERS  _top,_left,_display
*ķ
*_top     = _top line of pictures                                           
*_left    = _left end of pictures                                           
*_display = _display to display (can be string or numeric)                  
*                                                                           
*characters that can be displayed are: ABCDEFGHIJKLMNOPQRSTUVQXYZ           
*                                      0123456789.-+*/:"'!%?$               
*other characters will be displayed as a space                              
*lower case is automatically converted to upper case                        
*                                                                           
* If the _left parameter is passed as anything but a character, big_let will
* attempt to center the large characters in the display                     
*Ķ
* Example:                                                                  
*                                                                           
* big_let(10,.f.,ampm(time()))   && Centers the clock on the screen         
*                                                                           
* or                                                                        
*                                                                           
* big_let(10,1,ampm(time()))     && places the clock on column 1            
*Ķ
* The case statements improve the overall speed of the routine              
*Ľ
PRIVATE X,This_part,_strlen,_result

_display = UPPER(_display)

_strlen = LEN(_display)

Line6 = ''
IF TYPE('_left') <> 'N'
   _result = 0
   
   FOR X = 1 TO _strlen
      This_part = SUBSTR(_display,X,1)
      _result   = _result + IIF(This_part $ [.:'!],3,7)
   NEXT
   
   _left = IIF(82-_result<0,0,(82 - _result) / 2)
   
ENDIF

FOR X = 1 TO _strlen                         &&ķ
   This_part = SUBSTR(_display,X,1)          &&Another set of letters   
   DO CASE                                   &&you can use if you don't 
   CASE This_part $ 'ABCDEFGHIJKLM'          &&want the shaows.         
      DO CASE                                &&Ľ
         
      CASE This_part = 'A'                         &&  '
         Line1 = ''                         &&    '
         Line2 = '߱'                         &&  '
         Line3 = ''                         &&    '
         Line4 = '߱'                         &&    '
         Line5 = ' '                         &&        '
         Line6 = '   '
      CASE This_part = 'B'                         &&  '
         Line1 = ''                        &&     '
         Line2 = ' ߱'                        &&    '
         Line3 = ' '                        &&     '
         Line4 = ' ߱'                        &&  '
         Line5 = ''                        &&        '
         Line6 = ' '
      CASE This_part = 'C'                         &&  '
         Line1 = ''                         &&      '
         Line2 = ''                         &&      '
         Line3 = '    '                         &&      '
         Line4 = '    '                         &&  '
         Line5 = ''                         &&        '
         Line6 = ' '
      CASE This_part = 'D'                         &&  '
         Line1 = ''                        &&     '
         Line2 = ' ߱'                        &&     '
         Line3 = '  '                        &&     '
         Line4 = '  '                        &&  '
         Line5 = ''                        &&        '
         Line6 = ' '
      CASE This_part = 'E'                         &&  '
         Line1 = ''                         &&      '
         Line2 = ''                         &&    '
         Line3 = '  '                         &&      '
         Line4 = '  '                         &&  '
         Line5 = ''                         &&        '
         Line6 = ' '
      CASE This_part = 'F'                         &&  '
         Line1 = ''                         &&      '
         Line2 = ''                         &&    '
         Line3 = '  '                         &&      '
         Line4 = '  '                         &&      '
         Line5 = '    '                         &&        '
         Line6 = '     '
      CASE This_part = 'G'                         &&  '
         Line1 = ''                        &&      '
         Line2 = ''                        &&   '
         Line3 = ' '                        &&    '
         Line4 = '  '                        &&  '
         Line5 = ''                        &&        '
         Line6 = ' '
      CASE This_part = 'H'                         &&    '
         Line1 = ' '                         &&    '
         Line2 = ' '                         &&  '
         Line3 = ''                         &&    '
         Line4 = '߱'                         &&    '
         Line5 = ' '                         &&        '
         Line6 = '   '
      CASE This_part = 'I'                         &&   '
         Line1 = ''                           &&     '
         Line2 = ' '                           &&     '
         Line3 = '  '                           &&     '
         Line4 = '  '                           &&   '
         Line5 = ''                           &&       '
         Line6 = ' '
      CASE This_part = 'J'                         &&    '
         Line1 = '   '                        &&      '
         Line2 = '    '                        &&      '
         Line3 = '     '                        &&     '
         Line4 = '   '                        &&   '
         Line5 = ' '                        &&       '
         Line6 = '  '
      CASE This_part = 'K'                         &&    '
         Line1 = '  '                        &&    '
         Line2 = ' '                        &&    '
         Line3 = ' '                        &&    '
         Line4 = '߱ '                        &&    '
         Line5 = '  '                        &&       '
         Line6 = '    '
      CASE This_part = 'L'                         &&      '
         Line1 = '    '                         &&      '
         Line2 = '    '                         &&      '
         Line3 = '    '                         &&      '
         Line4 = '    '                         &&  '
         Line5 = ''                         &&        '
         Line6 = ' '
      CASE This_part = 'M'                         &&  '
         Line1 = ''                       &&    '
         Line2 = '۱۱'                       &&    '
         Line3 = '۱۱'                       &&      '
         Line4 = ' ߱'                       &&      '
         Line5 = '   '                       &&          '
         Line6 = '     '
      ENDCASE
      
      Add_on = LEN(Line1) + 1
   CASE This_part $ 'NOPQRSTUVWXYZ'
      
      DO CASE
      CASE This_part = 'N'
         Line1 = 'ܱ'                     &&   '
         Line2 = '۱۱'                     &&    '
         Line3 = '۱۱'                     &&    '
         Line4 = '۱۱'                     &&    '
         Line5 = '۱'                     &&   '
         Line6 = '  '                     &&          '
      CASE This_part = 'O'
         Line1 = ''                         &&  '
         Line2 = '߱'                         &&    '
         Line3 = ' '                         &&    '
         Line4 = ' '                         &&    '
         Line5 = ''                         &&  '
         Line6 = ' '                         &&        '
      CASE This_part = 'P'
         Line1 = ''                         &&  '
         Line2 = '߱'                         &&    '
         Line3 = ''                         &&  '
         Line4 = ''                         &&      '
         Line5 = '    '                         &&      '
         Line6 = '     '                         &&        '
      CASE This_part = 'Q'
         Line1 = ''                         &&  '
         Line2 = '߱'                         &&    '
         Line3 = ' '                         &&    '
         Line4 = '۱'                         &&   '
         Line5 = ''                         &&  '
         Line6 = ' ߱'                         &&      '
      CASE This_part = 'R'
         Line1 = ''                         &&  '
         Line2 = '߱'                         &&    '
         Line3 = ''                         &&  '
         Line4 = '۱'                         &&    '
         Line5 = ' '                         &&    '
         Line6 = '   '                         &&        '
      CASE This_part = 'S'
         Line1 = ''                         &&  '
         Line2 = ''                         &&      '
         Line3 = ''                         &&  '
         Line4 = ' ߱'                         &&      '
         Line5 = ''                         &&  '
         Line6 = ' '                         &&        '
      CASE This_part = 'T'
         Line1 = ''                       &&  '
         Line2 = ' ߱'                       &&        '
         Line3 = '      '                       &&        '
         Line4 = '      '                       &&        '
         Line5 = '      '                       &&        '
         Line6 = '       '                       &&          '
      CASE This_part = 'U'
         Line1 = ' '                         &&    '
         Line2 = ' '                         &&    '
         Line3 = ' '                         &&    '
         Line4 = 'ܱ'                         &&    '
         Line5 = ''                         &&  '
         Line6 = ' '                         &&        '
      CASE This_part = 'V'
         Line1 = '      '                  &&         '
         Line2 = '     '                  &&         '
         Line3 = '     '                  &&         '
         Line4 = '   ۱  '                  &&         '
         Line5 = '       '                  &&          '
         Line6 = '         '                  &&             '
      CASE This_part = 'W'
         Line1 = '   '                       &&      '
         Line2 = '۱ܱ'                       &&    '
         Line3 = '۱۱'                       &&    '
         Line4 = '۱۱'                       &&    '
         Line5 = ''                       &&  '
         Line6 = ' '                       &&          '
      CASE This_part = 'X'
         Line1 = '   '                       &&      '
         Line2 = '  '                       &&      '
         Line3 = '   '                       &&      '
         Line4 = ' ߱ '                       &&      '
         Line5 = '  '                       &&      '
         Line6 = '     '                       &&          '
      CASE This_part = 'Y'
         Line1 = ' '                         &&    '
         Line2 = ' '                         &&    '
         Line3 = ''                         &&  '
         Line4 = ' ߱'                         &&      '
         Line5 = ''                         &&  '
         Line6 = ' '                         &&        '
      CASE This_part = 'Z'
         Line1 = ''                         &&  '
         Line2 = ' ߱'                         &&      '
         Line3 = '   '                         &&      '
         Line4 = '   '                         &&      '
         Line5 = ''                         &&  '
         Line6 = ' '                         &&        '
         
      ENDCASE
      
      Add_on = LEN(Line1) + 1
      
   CASE This_part $ '01234I'
      DO CASE
         
      CASE This_part = '0'
         Line1 = ''       &&
         Line2 = '߱'       &&  
         Line3 = ' '       &&  
         Line4 = ' '       &&  
         Line5 = ''       &&
         Line6 = ' '
      CASE This_part = '1'
         Line1 = '   '       && 
         Line2 = '    '       &&  
         Line3 = '    '       &&  
         Line4 = '    '       &&  
         Line5 = ''       &&
         Line6 = ' '
      CASE This_part = '2'
         Line1 = ''       &&
         Line2 = ' ߱'       &&    
         Line3 = ''       &&
         Line4 = ''       &&
         Line5 = ''       &&
         Line6 = ' '
      CASE This_part = '3'
         Line1 = ''       &&
         Line2 = ' ߱'       &&    
         Line3 = ' '       && 
         Line4 = '  ߱'       &&    
         Line5 = ''       &&
         Line6 = ' '
      CASE This_part = '4'
         Line1 = ' '       &&  
         Line2 = ' '       &&  
         Line3 = ''       &&
         Line4 = ' ߱'       &&    
         Line5 = '    '       &&    
         Line6 = '     '
      ENDCASE
      Add_on = LEN(Line1) + 1
   CASE This_part $ '56789'
      DO CASE
      CASE This_part = '5'
         Line1 = ''           &&  
         Line2 = ''           &&  
         Line3 = ''           &&  
         Line4 = ' ߱'           &&      
         Line5 = ''           &&  
         Line6 = ' '
      CASE This_part = '6'
         Line1 = ''           &&  
         Line2 = ''           &&  
         Line3 = ''           &&  
         Line4 = '߱'           &&    
         Line5 = ''           &&  
         Line6 = ' '
      CASE This_part = '7'
         Line1 = ''           &&  
         Line2 = ' ߱'           &&      
         Line3 = '    '           &&      
         Line4 = '    '           &&      
         Line5 = '    '           &&      
         Line6 = '     '
      CASE This_part = '8'
         Line1 = ''           &&  
         Line2 = '߱'           &&    
         Line3 = ''           &&  
         Line4 = '߱'           &&    
         Line5 = ''           &&  
         Line6 = ' '
      CASE This_part = '9'
         Line1 = ''           &&  
         Line2 = '߱'           &&    
         Line3 = ''           &&  
         Line4 = ' ߱'           &&      
         Line5 = ''           &&  
         Line6 = ' '
      ENDCASE
      Add_on = LEN(Line1) + 1
   OTHERWISE
      DO CASE
      CASE This_part = '.'
         Line1 = '   '
         Line2 = '   '
         Line3 = '   '
         Line4 = '   '
         Line5 = ''
         Line6 = ' '
      CASE This_part = '-'
         Line1 = '       '
         Line2 = '       '
         Line3 = ''                && 
         Line4 = ' '
         Line5 = '       '
         Line6 = '       '
      CASE This_part = '+'
         Line1 = '       '
         Line2 = '    '                &&    
         Line3 = ''                &&  
         Line4 = ' ߱'                &&    
         Line5 = '     '
         Line6 = '       '
      CASE This_part = '='
         Line1 = '       '
         Line2 = ''
         Line3 = ' '
         Line4 = ''
         Line5 = ' '
         Line6 = '       '
      CASE This_part = '*'
         Line1 = '    '
         Line2 = '   '
         Line3 = '  '
         Line4 = '   '
         Line5 = '    '
         Line6 = '     '
      CASE This_part = ':'
         Line1 = ' '
         Line2 = ''
         Line3 = ' '
         Line4 = ''
         Line5 = ' '
         Line6 = ' '
      CASE This_part = '"'
         Line1 = 'ܱ'
         Line2 = '  '
         Line3 = '    '
         Line4 = '      '
         Line5 = '      '
         Line6 = '      '
      CASE This_part = "'"
         Line1 = ''
         Line2 = ' '
         Line3 = '  '
         Line4 = '   '
         Line5 = '   '
         Line6 = '   '
      CASE This_part = ','
         Line1 = '    '
         Line2 = '    '
         Line3 = '    '
         Line4 = '    '
         Line5 = ' '
         Line6 = '  '
      CASE This_part = '!'
         Line1 = ''
         Line2 = ''
         Line3 = ''
         Line4 = ' '
         Line5 = ''
         Line6 = ' '
      CASE This_part = '%'
         Line1 = '   '
         Line2 = '  '
         Line3 = '   '
         Line4 = '    '
         Line5 = '   '
         Line6 = '     '
      CASE This_part = '/'
         Line1 = '    '
         Line2 = '   '
         Line3 = '   '
         Line4 = '    '
         Line5 = '    '
         Line6 = '     '
      CASE This_part = '?'
         Line1 = ''
         Line2 = ' ߱'
         Line3 = '  '
         Line4 = '   '
         Line5 = '    '
         Line6 = '     '
      CASE This_part = '$'
         Line1 = ''
         Line2 = '   '
         Line3 = ''
         Line4 = '   '
         Line5 = ''
         Line6 = '    '
      CASE This_part = ' '
         Line1 = ''
         Line2 = ''
         Line3 = ''
         Line4 = ''
         Line5 = ''
         Line6 = ''
      OTHERWISE
         Line1 = '  '
         Line2 = '  '
         Line3 = '  '
         Line4 = '  '
         Line5 = '  '
         Line6 = '  '
      ENDCASE
      Add_on = IIF(This_part $ [.:'!],2,IIF(EMPTY(This_part),2,7))
   ENDCASE
   
   IF _left + Add_on + LEN(Line1) > 82
      ? 'LINE IS TOO LONG!!'
      EXIT
   ENDIF
   
   @ _top  ,_left SAY  Line1
   @ _top+1,_left SAY  Line2
   @ _top+2,_left SAY  Line3
   @ _top+3,_left SAY  Line4
   @ _top+4,_left SAY  Line5
   @ _top+5,_left SAY  Line6
   
   _left = _left + Add_on
   
NEXT

RETURN .T.

* EOF-> BIGLETTS.PRG
